<?php
App::uses('Component', 'Controller');

class FbPixelComponent extends Component {

	protected $_controller = null;

	protected $_pixelItems = [];

/**
 * Sets a reference to the calling controller from within the component.
 *
 * @see Component::initialize()
 */
	public function initialize(Controller $controller) {
		parent::initialize($controller);
		$this->_controller = $controller;
	}

/**
 * Returns JSON encoded event data for Facebook pixel tracking.
 *
 * @param float $totalCost Total cost
 * @param string $currency Currency code
 * @param string $contentType Product type
 * @return string
 */
	public function transaction($totalCost, $currency = null, $contentType = 'product') {
		$currency = $currency ?: CakeNumber::defaultCurrency();
		$data = [
			'content_ids' => $this->_pixelItems,
			'content_type' => $contentType,
			'value' => $totalCost,
			'currency' => $currency
		];

		return json_encode($data);
	}

/**
 * Adds an item to the content_ids array.
 *
 * @param string $sku SKU/Product code
 * @return void
 */
	public function addItem($sku) {
		$this->_pixelItems[] = $sku;

		return;
	}

}
